#ifndef __BYTEBUFFER_H
#define __BYTEBUFFER_H

#include <iostream>
#include <stdio.h>
#include <vector>
#include <sstream>

typedef unsigned char byte;

using namespace std;

namespace simplis
{	
	class ByteBuffer
	{
	private:
		//! Store the completed bytes.
		vector<byte> bytes;

		//! The byte currently used.
		byte current;

		//! The position in the buffer.
		int position;

	protected:
		//! Put a bit into the buffer.
		bool putBit(bool bit);

		//! Finish the bytebuffer.
		void flush();
	public:
		//! Write a number to the buffer.
		void writeNumeric(int value, int alignment);

		//! Fix the buffer's alignment.
		void pack();

		//! Create a new byte buffer.
		ByteBuffer();

		//! Convert the buffer to a string.
		string toString() const;

		//! Appends the buffer at a file.
		void appendToFile(const string& name);
	
	};
}

#endif
