// Include declaration.
#include "../include/exception.h"

/*!
 *	The parameterless constructor is hidden, so the application
 *	cannot create exception with no additionanl information on
 *	the circumstances of it's creation.
 */
simplis::Exception::Exception()
{
}

/*!
 *	This default constructor is used to create an exception
 *	with additional information on it's creation, like i.e.
 *	the location in the programm that created the exception.
 *
 *	@param file The name of the file that threw the exception.
 *	@param line The line in the file that threw the exception.
 *	@param data Additional data transported with the excpetion.
 */
simplis::Exception::Exception(const std::string& file, const unsigned int& line, const std::string& data)
{
	this->file = file;
	this->line = line;
	this->data = data;
	#ifdef REPORT_IMMEDIATELY
	{
		printf("\x1b[31m[Exception %s:%d] %s\x1b[0m\n", file.c_str(), line, data.c_str());
	}
	#endif
}
